local function SpeedRun(player)
	local speedrun = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun and speedrun.valid
		speedrun.state = S_SCARFSPEED
		speedrun.angle = player.drawangle
		speedrun.momx = 3*player.mo.momx/4
		speedrun.momy = 3*player.mo.momy/4
		speedrun.momz = 3*player.mo.momz/4
		speedrun.scale = player.mo.scale
		speedrun.color = player.mo.color
		speedrun.colorized = true
		speedrun.blendmode = AST_ADD
	end
end

addHook("FollowMobj", function(player, mobj)
	local mo = player.mo
	if not (mo and mo.valid and mobj and mobj.valid) 
		return true 
	end
	mobj.flags2 = $&~MF2_LINKDRAW
	if player.powers[pw_super] 
	and player.armaform
		mobj.skin = mo.skin
		mobj.rollangle = mo.rollangle
		mobj.mirrored = mo.mirrored
		mobj.spritexscale = mo.spritexscale
		mobj.spriteyscale = mo.spriteyscale
		mobj.spritexoffset = mo.spritexoffset
		mobj.spriteyoffset = mo.spriteyoffset
		mobj.renderflags = $|RF_FULLBRIGHT
		mobj.sprite2 = mo.sprite2
		mobj.angle = player.drawangle
		if (leveltime % 8 == 0)
			mobj.state = S_SCARFAURA
			mobj.scale = mo.scale
			mobj.flags2 = mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
			mobj.eflags = mo.eflags&MFE_VERTICALFLIP
			mobj.blendmode = AST_ADD
			mobj.color = SKINCOLOR_KETCHUP
			mobj.colorized = true
			mobj.frame = $ & ~FF_TRANSMASK | TR_TRANS50
			mobj.fuse = 0
			mobj.tics = 10
			mobj.target = player.mo
			mobj.fuse = 0
		end
	end
	if not player.powers[pw_super] 
	and not player.armaform
		mobj.state = S_INVISIBLE
	end
end, MT_SCARF_AURA)

local function MaxSpeedRun(player)
	local speedrun2 = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun2 and speedrun2.valid
		speedrun2.state = S_MAXSCARFSPEED1
		speedrun2.angle = player.drawangle
		speedrun2.momx = 3*player.mo.momx/4
		speedrun2.momy = 3*player.mo.momy/4
		speedrun2.momz = 3*player.mo.momz/4
		speedrun2.scale = player.mo.scale
		speedrun2.color = player.mo.color
		speedrun2.colorized = true
		speedrun2.blendmode = AST_ADD
	end
end

addHook("ShieldSpecial", function(player)
	if (player.mo and player.valid and player.mo.skin == "scarf")
		return true
	end
end)

local function scarffloat(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_RED
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
		spawnedmo.fuse = 8
		spawnedmo.destscale = 0
    end
end

local function scarfjump(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = mo.color
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
		spawnedmo.fuse = 8
		spawnedmo.destscale = 0
    end
end

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	if mo.type == MT_LIGHTBURST
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
	else
		P_TeleportMove(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
	end
	mo.rollangle = mo.target.rollangle
	mo.angle = mo.target.player.drawangle
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	if mo.type == MT_LIGHTBURSTOBJECT
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
	else
		P_TeleportMove(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
	end
	mo.rollangle = mo.target.rollangle
	mo.angle = mo.target.player.drawangle
end, MT_LIGHTBURSTOBJECT)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	if mo.type == MT_SCARFPRIORITY
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
	else
		P_TeleportMove(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
	end
	if (mo.eflags & MFE_VERTICALFLIP)
		mo.z = mo.target.z+(mo.target.height/2)
	end
	mo.rollangle = mo.target.rollangle
	mo.angle = mo.target.player.drawangle
	mo.scale = mo.target.scale
end, MT_SCARFPRIORITY)

addHook("MobjDeath", function(mo)
	if mo and mo.valid
		return true
	end
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		mo.shadowscale = 0
		if mo.target and mo.target.player
			if mo.target.player.playerstate == PST_DEAD
			or P_PlayerInPain(mo.target.player)
			or mo.target.player.state == S_PLAY_DEAD
			or mo.target.player.state == S_PLAY_DRWN
			or mo.target.player.state == S_PLAY_STUN //Why not?
				P_RemoveMobj(mo)
			end
		end
	end
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFSHOT
		local plasmaparticle = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_FIREBALLTRAIL)
		plasmaparticle.color = SKINCOLOR_SKY
		plasmaparticle.colorized = true
		plasmaparticle.scale = 1*FRACUNIT/2
		plasmaparticle.destscale = 1*FRACUNIT/4
		plasmaparticle.momz = 2*FRACUNIT
		local plasmaparticle2 = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_PUMATRAIL)
		plasmaparticle2.color = SKINCOLOR_CYAN
		plasmaparticle2.colorized = true
		plasmaparticle2.scale = 1*FRACUNIT/2
		plasmaparticle2.destscale = 1*FRACUNIT/4
		plasmaparticle2.momz = 2*FRACUNIT
		mo.color = SKINCOLOR_CYAN
		mo.colorized = true
		mo.blendmode = AST_ADD
		local scarfspark = P_SpawnMobjFromMobj(mo,P_RandomRange(-6, 6)*FRACUNIT,P_RandomRange(-6, 6)*FRACUNIT,P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
		scarfspark.state = S_NIGHTSPARKLE1
		scarfspark.angle = mo.angle + ANGLE_90
		scarfspark.color = SKINCOLOR_CYAN
		scarfspark.colorized = true
		scarfspark.blendmode = AST_ADD
		scarfspark.colorized = true
		scarfspark.fuse = 6
		scarfspark.destscale = 0
		local scarfelectric = P_SpawnMobjFromMobj(mo,P_RandomRange(-6, 6)*FRACUNIT,P_RandomRange(-6, 6)*FRACUNIT,P_RandomRange(0, 6)*FRACUNIT, MT_THOK)
		scarfelectric.state = S_SCARFSHOK
		scarfelectric.angle = mo.angle + ANGLE_90
		scarfelectric.color = SKINCOLOR_CYAN
		scarfelectric.colorized = true
		scarfelectric.blendmode = AST_ADD
		scarfelectric.colorized = true
		scarfelectric.fuse = 8
		scarfelectric.destscale = 0
		if mo.tics % 3 == 0 or mo.flags2 & MF2_AMBUSH
			local scarfplasmaghost = P_SpawnGhostMobj(mo)
			scarfplasmaghost.colorized = true
			scarfplasmaghost.blendmode = AST_ADD
		end
		if mo.tics % 2
			local rollscarfspark = P_SpawnMobjFromMobj(mo,
			P_RandomRange(-6, 6)*FRACUNIT,
			P_RandomRange(-6, 6)*FRACUNIT,
			P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
			rollscarfspark.state = S_SCARF_ARMA_PARTICLES
			rollscarfspark.target = mo
			rollscarfspark.angle = mo.angle + ANGLE_90
			rollscarfspark.color = mo.color
			rollscarfspark.colorized = true
			rollscarfspark.blendmode = AST_ADD
			rollscarfspark.fuse = 8
			rollscarfspark.destscale = 0
		end
	end
end)

local function ScarfJump(player)
	local mo = player.mo
	if player.powers[pw_carry]
		return
	end
	if player.speed >= FixedMul(mo.scale,player.runspeed)
		mo.state = S_PLAY_GLIDE
	else
		mo.state = P_MobjFlip(mo)*mo.momz > 0 and S_PLAY_SPRING or S_PLAY_FALL
	end
end

addHook("MobjThinker", function(mo)
    if mo and mo.valid
        if not mo.source return end
        mo.lifetime = $ or 0
        P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
        mo.lifetime = $ + 1
    end
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
    if not mo.source return end
    mo.lifetime = $ or 0
    P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
    mo.lifetime = $ + 1
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
    if mo and mo.valid
        if not mo.source return end
        mo.lifetime = $ or 0
        P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
        mo.lifetime = $ + 1
    end
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
    if not mo.source return end
    mo.lifetime = $ or 0
    P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
    mo.lifetime = $ + 1
end, MT_SCARFARMAELECTICPARTICLE)

local scarfpreent = 5

local scarfghostcolorized = 2*TICRATE

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "scarf")
			if player.hudvanilla_animation == nil
			or player.hudvanilla_animation == 24
				player.hudvanilla_animation = 1
			else
				player.hudvanilla_animation = $+1
			end
			if player.hudvanilla_animation > 24
				player.hudvanilla_animation = 24
			end
		end
		if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		and not player.exiting
			local cv_chasecam = CV_FindVar("chasecam")
			local cv_chasecam2 = CV_FindVar("chasecam2")
			if player.powers[pw_carry]
			or P_PlayerInPain(player)
				if player.mo.swordstate > 1
					player.mo.swordstate = 0
				end
				if player.mo.swordmah
				and player.mo.swordmah.valid
					P_RemoveMobj(player.mo.swordmah)
					player.mo.swordmah = nil
				end
			end
			//Arma Form Function
			if player.armaform
			and not player.powers[pw_super]
			and not player.powers[pw_extralife]
			and not (player.exiting)
			//Arma Form Activated
				player.armaform = false
			end
			if (player.gotflag or player.gotcrystal)
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if player.rings >= 150
			and ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
			and not player.armaform
			and player.powers[pw_super]
				player.armaform = true
				P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
				P_StartQuake(79*FRACUNIT, 3)
				P_FlashPal(player, PAL_WHITE, 3)
				P_NukeEnemies(player.mo, player.mo, RING_DIST)
			end
			//Speed in a 55 fracunit
			if player.speed >= player.runspeed
			and (player.speed > 55*FRACUNIT)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				SpeedRun(player)
				if leveltime % (TICRATE+TICRATE/2) == 4
					S_StartSound(player.mo, sfx_whlspd)
				end
			end
			if player.speed >= player.runspeed
			and (player.speed < 55*FRACUNIT)
				S_StopSoundByID(player.mo, sfx_whlspd)
			end
			if not (player.mo.sworddash)
				player.mo.sworddash = 0
			end
			if player.mo.sworddash > 0
				player.mo.sworddash = $1 - 1
			end
			if not (player.mo.lightburst)
				player.mo.lightburst = 0
			end
			if player.mo.lightburst > 0
				player.mo.lightburst = $1 - 1
			end
			//Light Burst
			if player.mo.lightburst > 1
			and player.playerstate == PST_LIVE
				player.powers[pw_nocontrol] = 2
				player.pflags = $|PF_FULLSTASIS
				P_SpawnPlayerMissile(player.mo, MT_LIGHTBURSTOBJECT)
			end
			if player.mo.lightburst == 1
				player.pflags = $1 & ~PF_FULLSTASIS
			end
			if player.playerstate == PST_LIVE
				player.pflags = $1 & ~PF_SHIELDABILITY
			end
			//Jump
			if (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_THOKKED)
			and not P_IsObjectOnGround(player.mo)
			and player.playerstate == PST_LIVE
				ScarfJump(player)
			end
			//Float/Hover Dash
			if player.mo.sworddash > 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.momz = 0
				player.pflags = $1|PF_JUMPED
				player.mo.state = S_PLAY_GLIDE
				player.drawangle = player.mo.angle
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric.color = SKINCOLOR_RED
				electric.colorized = true
				electric.blendmode = AST_ADD
				electric.state = S_WATERZAP
				local boostdash = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				boostdash.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_KETCHUP)
				boostdash.colorized = true
				boostdash.blendmode = AST_ADD
				boostdash.sprite = SPR_FIRS
				boostdash.frame = S|FF_TRANS50
				boostdash.angle = player.mo.angle
				boostdash.fuse = 1
				if not player.powers[pw_super]
				and not player.powers[pw_sneakers]
				and not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
				elseif player.powers[pw_super]
				and not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
				elseif player.powers[pw_super]
				and (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT/2)
				elseif player.powers[pw_sneakers]
				and not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
				elseif player.powers[pw_sneakers]
				and (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT/2)
				elseif not player.powers[pw_super]
				and not player.powers[pw_sneakers]
				and (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT/2)
				end
				if player == displayplayer and not splitscreen
					P_StartQuake(FRACUNIT, 3)
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					aura.flags2 = $|MF2_DONTDRAW
					electric.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.playerstate == PST_DEAD
				player.charability = CA_NONE
				if CBW_Battle
					player.mo.lightburst = 1
				end
			end
			if player.playerstate == PST_LIVE
			and (player.exiting)
				player.charability = CA_NONE
			end
			if (P_IsObjectOnGround(player.mo))
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if not (player.mo.swordstate)
				player.mo.swordstate = 0
			end
			if player.mo.swordstate > 0
				player.mo.swordstate = $1 - 1
			end
			//Sword
			if player.mo.swordstate > 1
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				player.charflags = $|SF_CANBUSTWALLS
				P_SPMAngle(player.mo, MT_SWORDDAMAGE, player.drawangle, 0)
				player.mo.scarfplasma = 0
				if player.powers[pw_justsprung]
				or (player.mo.eflags & MFE_SPRUNG)
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					player.mo.swordstate = 0
					player.weapondelay = 10
					S_StartSound(player.mo, sfx_sprong)
					local swordghost = P_SpawnGhostMobj(player.mo) 
					if swordghost and swordghost.valid
						swordghost.color = SKINCOLOR_RED
						swordghost.colorized = true
						swordghost.destscale = $ * 2
						swordghost.blendmode = AST_ADD
						swordghost.target = player.mo
					end
					if (player.mo.state != S_SCARF_SWORD1
					or player.mo.state != S_SCARF_SWORD2
					or player.mo.state != S_SCARF_SWORD3
					or player.mo.state != S_SCARF_SWORD4
					or player.mo.state != S_SCARF_SWORD5
					or player.mo.state != S_SCARF_SWORD6
					or player.mo.state != S_SCARF_SWORD7)
						player.mo.state = S_SCARF_SWORD1
					end
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				if player.armaform == true
					player.pflags = $1|PF_JUMPED
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			or player.powers[pw_carry]
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if (player.mo.state == S_PLAY_SPRING)
			and (player.mo.state == S_PLAY_FALL)
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if not (player.mo.usedown)
				player.mo.usedown = 0
			end
			if not (player.mo.custom2down)
				player.mo.custom2down = 0
			end
			if not (player.mo.swordjump)
				player.mo.swordjump = 0
			end
			if player.mo.swordjump > 0
				player.mo.swordjump = $1 - 1
			end
			//Sprite Swords
			if player.mo.swordstate > 1
			and player.playerstate == PST_LIVE
				if player.mo.swordmah
					if player.mo.swordmah.valid
						local swordmah = player.mo.swordmah
						local angle = R_PointToAngle2(swordmah.x, swordmah.y, player.mo.x+player.mo.momx+FixedMul(cos(player.drawangle), player.mo.radius*2), player.mo.y+player.mo.momy+FixedMul(sin(player.drawangle), player.mo.radius*2))
						local dist = R_PointToDist2(swordmah.x, swordmah.y, player.mo.x+player.mo.momx+FixedMul(cos(player.drawangle), player.mo.radius*2), player.mo.y+player.mo.momy+FixedMul(sin(player.drawangle), player.mo.radius*2))
						swordmah.angle = player.drawangle
						swordmah.z = player.mo.z+player.mo.height/4+player.mo.momz
						swordmah.scale = player.mo.scale+FRACUNIT/4
						swordmah.flags2 = $|MF2_SPLAT
						swordmah.renderflags = $1|RF_NOSPLATBILLBOARD
						swordmah.momz = 0
						P_InstaThrust(swordmah, angle, dist)
					end
				end
			end
			//Arma Particles Part 1
			if player.powers[pw_super] and player.armaform == true
				local sparkle2 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				sparkle2.momx = P_RandomRange(-5, 5) * FRACUNIT
				sparkle2.momy = P_RandomRange(-5, 5) * FRACUNIT
				sparkle2.momz =  P_RandomRange(-5, 5) * FRACUNIT
				sparkle2.color = SKINCOLOR_KETCHUP
				sparkle2.colorized = true
				sparkle2.blendmode = AST_ADD
				sparkle2.scale = player.mo.scale/3*2
				sparkle2.source = player.mo
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					sparkle2.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.mo.swordstate == 1
			or (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			or player.playerstate == PST_DEAD
			or not player.mo.state == S_SCARF_SWORD1
			or P_PlayerInPain(player)
			or player.mo.state == S_PLAY_STUN 
			or player.mo.state == S_PLAY_DEAD 
			or player.mo.state == S_PLAY_DRWN
			or player.mo.sprite == SPR2_TRNS
			or not player.mo.skin == "scarf" //Swap
				player.charflags = $ & ~SF_CANBUSTWALLS
				if player.mo.swordmah and player.mo.swordmah.valid then
					P_KillMobj(player.mo.swordmah)
					player.mo.swordmah = nil
				end
				if player.armaform == true
					player.pflags = $1|PF_JUMPED
				end
				if (player.cmd.buttons & BT_USE)
				and not CBW_Battle
					player.mo.scarfplasma = 5
				elseif not (player.cmd.buttons & BT_USE)
				or P_PlayerInPain(player)
					player.mo.scarfplasma = 0
				end
			end
			if (player.mo.state == S_PLAY_SUPER_TRANS1
			or player.mo.state == S_PLAY_SUPER_TRANS2
			or player.mo.state == S_PLAY_SUPER_TRANS3
			or player.mo.state == S_PLAY_SUPER_TRANS4
			or player.mo.state == S_PLAY_SUPER_TRANS5
			or player.mo.state == S_PLAY_SUPER_TRANS6)
				player.mo.swordstate = 0
			end
			//Sword Jump
			if player.mo.swordjump > 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_SPRING
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_THOKKED
				A_BossScream(player.mo, 0, 	MT_BOXSPARKLE)
				local electric3 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric3.blendmode = AST_MODULATE
				electric3.state = S_WATERZAP
				electric3.fuse = 8
				if (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
				else
					P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					electric3.flags2 = $|MF2_DONTDRAW
				end
				local scarf_aura_jump = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				scarf_aura_jump.sprite = SPR_SCLL
				scarf_aura_jump.frame = A|FF_TRANS50
				scarf_aura_jump.fuse = 1
				scarf_aura_jump.color = player.mo.color
				scarf_aura_jump.colorized = true
				scarf_aura_jump.blendmode = AST_ADD
				if player.mo.eflags & MFE_VERTICALFLIP
					scarf_aura_jump.eflags = $1|MFE_VERTICALFLIP
				else
					scarf_aura_jump.eflags = $ & ~MFE_VERTICALFLIP
				end
			end
			if player.mo.swordjump > 1
				player.mo.sworddash = 0
			end
			//Night Special
			if (player.powers[pw_carry] == CR_NIGHTSMODE)
				local nightfireparticle = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_FLAMEPARTICLE)
				nightfireparticle.fuse = 7
				nightfireparticle.color = SKINCOLOR_RED
				nightfireparticle.colorized = true
				nightfireparticle.scale = player.mo.scale/2
				nightfireparticle.blendmode = AST_ADD
				if (leveltime & 3) == 1
					local ghostnight = P_SpawnGhostMobj(player.mo)
					ghostnight.color = SKINCOLOR_RED
					ghostnight.colorized = true
					ghostnight.blendmode = AST_ADD
					ghostnight.destscale = $ * 2
				end
			end
			if not (player.mo.scarfplasma)
				player.mo.scarfplasma = 0
			end
			if player.mo.scarfplasma > 0
				player.mo.scarfplasma = $1 - 1
			end
			if player.mo.scarfplasma > 1
			and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_USE)
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.scarfplasma = 5
				if (leveltime & 3) == 1
				or player.mo.tics % 2
					local scarfplasma_shield = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_FIREBALLTRAIL)
					scarfplasma_shield.color = SKINCOLOR_CYAN
					scarfplasma_shield.colorized = true
					scarfplasma_shield.blendmode = AST_ADD
					scarfplasma_shield.fuse = 8
					scarfplasma_shield.momz = 2
					scarfplasma_shield.scale = 1*FRACUNIT/2
					scarfplasma_shield.destscale = 1*FRACUNIT/4
					local scarfplasma_shield2 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT,MT_PUMATRAIL)
					scarfplasma_shield2.color = SKINCOLOR_SKY
					scarfplasma_shield2.colorized = true
					scarfplasma_shield2.blendmode = AST_ADD
					scarfplasma_shield2.fuse = 6
					scarfplasma_shield2.momz = 4
					scarfplasma_shield2.scale = 1*FRACUNIT/2
					scarfplasma_shield2.destscale = 1*FRACUNIT/4
					if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
						scarfplasma_shield.flags2 = $|MF2_DONTDRAW
						scarfplasma_shield2.flags2 = $|MF2_DONTDRAW
					end
				end
				if player.mo.colorized == false
					player.mo.color = SKINCOLOR_RED
					player.mo.colorized = true
				else
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
			end
			if player.mo.scarfplasma == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.state = S_SCARF_SWORD1
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				S_StartSound(player.mo, sfx_swordd)
				P_SpawnPlayerMissile(player.mo, MT_SCARFSHOT)
				S_StartSound(player.mo, sfx_s3k7c)
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				if player.mo.colorized == true
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
				if player.powers[pw_super]
				and player.armaform == true
					local scarfshotplasma1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.mo.angle-ANG2, 1)
					local scarfshotplasma2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.mo.angle+ANG2, 1)
				end
			end
			if not player.mo.scarfplasma
			or player.powers[pw_carry]
			or not (player.cmd.buttons & BT_USE)
			or P_PlayerInPain(player)
				if player.mo.colorized == true
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
			end
			if player.mo.swordjump == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local swordghoststate2 = P_SpawnGhostMobj(player.mo)
				swordghoststate2.color = SKINCOLOR_RED
				swordghoststate2.colorized = true
				swordghoststate2.blendmode = AST_ADD
				swordghoststate2.destscale = $ * 2
				player.mo.state = S_PLAY_JUMP
				S_StartSound(player.mo, sfx_cdwn)
			end
			//Shields
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
			or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
				if player.mo.swordstate > 1
				and (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					P_ElementalFire(player)
				end
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
			and not player.powers[pw_super]
			and not CBW_Battle
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
					A_OldRingExplode(player.mo, MT_SONIC3KBOSSEXPLODE)
					P_BlackOw(player)
					P_StartQuake(20*FRACUNIT, 35, {0, 0, 0}, player.mo.radius)
					P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
					P_StartQuake(79*FRACUNIT, 3)
					P_FlashPal(player, PAL_WHITE, 3)
					S_StartSound(player.mo, sfx_bkpoof)
					P_NukeEnemies(player.mo, player.mo, RING_DIST)
					S_StartSound(player.mo, sfx_bgxpld)
					player.mo.alreadyexploded = true
				end
			end
			if player.mo.windjump ~= nil and player.pflags & PF_JUMPED
				player.mo.windjump = $ + 1
			else
				player.mo.windjump = 0
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
			and player.mo.windjump == 1
			and not player.powers[pw_super]
			and not CBW_Battle
				player.mo.momz = 4*$/3
			end
			//Air
			if not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
			and not player.armaform
			and not player.powers[pw_carry]
				if player.powers[pw_justlaunched]
					player.mo.state = S_PLAY_SPRING
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.playerstate == PST_REBORN
				player.mo.rollangle = 0
			end
			if not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
			and player.powers[pw_super] and player.armaform == true
			and not player.powers[pw_carry]
				player.pflags = $1|PF_JUMPED|PF_NOJUMPDAMAGE
			end
			if not (player.mo.scarfdodge)
				player.mo.scarfdodge = 0
			end
			if player.mo.scarfdodge > 0
				player.mo.scarfdodge = $1 - 1
			end
			if player.mo.scarfdodge > 1
			and player.playerstate == PST_LIVE
			and not (P_IsObjectOnGround(player.mo))
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				S_StopSoundByID(player.mo, sfx_skid)
				player.mo.momx = FixedMul($, FRACUNIT*97/100)
				player.mo.momy = FixedMul($, FRACUNIT*97/100)
				player.powers[pw_nocontrol] = 2
				player.mo.state = S_PLAY_FALL
				player.mo.scarfdodge = 5
				player.mo.rollangle = $+ANGLE_22h
				player.mo.flags = $|MF_NOCLIPTHING
				player.drawangle = player.mo.angle
				if (leveltime & 3) == 1
					local scarfdodge = P_SpawnGhostMobj(player.mo)
					scarfdodge.color = scarfghostcolorized and SKINCOLOR_RED
					scarfdodge.colorized = true
					scarfdodge.blendmode = AST_ADD
					scarfdodge.destscale = 0
					scarfdodge.scale = player.mo.scale
					scarfdodge.scalespeed = player.mo.scalespeed*2
				end
			end
			if player.mo.scarfdodge == 1
			or (P_IsObjectOnGround(player.mo))
			or P_PlayerInPain(player)
			or player.powers[pw_carry]
			and player.playerstate == PST_LIVE
				player.mo.scarfdodge = 1
				player.mo.rollangle = 0
				player.mo.flags = $ & ~MF_NOCLIPTHING
			end
			if not (player.mo.scarfplasmabattle)
				player.mo.scarfplasmabattle = 0
			end
			if player.mo.scarfplasmabattle > 0
				player.mo.scarfplasmabattle = $1 - 1
			end
			if player.mo.scarfplasmabattle > 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.swordstate = 0
				player.mo.momz = 0
				player.mo.momx = FixedMul($, FRACUNIT*97/100)
				player.mo.momy = FixedMul($, FRACUNIT*97/100)
				player.powers[pw_nocontrol] = 2
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				player.mo.state = S_PLAY_SCARFSPINDASH
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				local sparkle3 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(10, -10) * FRACUNIT, P_RandomRange(10, -10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				sparkle3.momx = P_RandomRange(5, -5) * FRACUNIT
				sparkle3.momy = P_RandomRange(5, -5) * FRACUNIT
				sparkle3.momz =  P_RandomRange(5, -5) * FRACUNIT
				sparkle3.color = SKINCOLOR_CYAN
				sparkle3.colorized = true
				sparkle3.blendmode = AST_ADD
				sparkle3.scale = player.mo.scale/3*2
				sparkle3.source = player.mo
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					sparkle3.flags2 = $|MF2_DONTDRAW
				end
				if (leveltime % 8 == 0)
					local redelectricaura = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_SCARFPRIORITY)
					if redelectricaura and redelectricaura.valid then
						redelectricaura.target = player.mo
						redelectricaura.state = S_REDSCARFAURA
						redelectricaura.scale = player.mo.scale
						redelectricaura.spriteyoffset = -16*FRACUNIT
						redelectricaura.frame = FF_ANIMATE
						redelectricaura.color = SKINCOLOR_CYAN
						redelectricaura.colorized = true
						redelectricaura.fuse = 0
						redelectricaura.blendmode = AST_ADD
						if player.mo.scarfplasmabattle == 1
							redelectricaura.state = S_NULL
						end
					end
				end
				if player.powers[pw_justsprung]
				or (player.mo.eflags & MFE_SPRUNG)
				or player.powers[pw_carry]
				or P_PlayerInPain(player)
					player.mo.scarfplasmabattle = 0
				end
			end
			if player.mo.scarfplasmabattle == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.mo.state = S_SCARF_SWORD1
				S_StartSound(player.mo, sfx_swordd)
				S_StartSound(player.mo, sfx_s3k7c)
				P_SpawnPlayerMissile(player.mo, MT_SCARFSHOT)
				local scarfshot1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.mo.angle-ANG2, 1)
				local scarfshot2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.mo.angle+ANG2, 1)
			end
			//Crumble a Floor/Fof
			for x=player.mo.x,player.mo.x+player.mo.radius*2,player.mo.radius*2
				for y=player.mo.y,player.mo.y+player.mo.radius*2,player.mo.radius*2
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
						and player.mo.swordstate
							if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
								EV_CrumbleChain(ss.sector, fof)
								S_StartSound(player.mo, sfx_s3k5f)
							end
						end
					end
				end
			end
			if (player.cmd.buttons & BT_JUMP)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and player.armaform == true
				P_SetObjectMomZ(player.mo, FRACUNIT*3/2, 1)
			end
			if player.powers[pw_super] and player.armaform == true
				player.charability = CA_NONE
			end
			//Arma Particles Part 2
			if player.powers[pw_super] and player.armaform == true
				if (leveltime & 3) == 1
				or player.mo.tics % 2
					local scarfarma = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma.state = S_SCARF_ARMA_PARTICLES
					scarfarma.color = SKINCOLOR_RED
					scarfarma.colorized = true
					scarfarma.fuse = 8
					scarfarma.destscale = 0
					scarfarma.momz = 2
					local scarfarma2 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma2.state = S_SCARF_ARMA_PARTICLES
					scarfarma2.color = SKINCOLOR_RUBY
					scarfarma2.colorized = true
					scarfarma2.fuse = 6
					scarfarma2.destscale = 0
					scarfarma2.momz = 4
					if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
						scarfarma.flags2 = $|MF2_DONTDRAW
						scarfarma2.flags2 = $|MF2_DONTDRAW
					end
				end
			end
			if player.mo.sworddash == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_FALL
				player.pflags = $ & ~PF_DRILLING
				player.pflags = $ & ~PF_JUMPED
				S_StartSound(player.mo, sfx_skid)
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/2)
				elseif (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT)
				end
			end
			//Dodge
			if (player.cmd.buttons & BT_CUSTOM2)
			and (player.cmd.forwardmove > 0 
			or player.cmd.forwardmove < 0
			or player.cmd.sidemove > 0
			or player.cmd.sidemove < 0)
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.custom2down == 0
			and not player.armaform
			and player.playerstate == PST_LIVE
			and (P_IsObjectOnGround(player.mo))
			and not (player.gotflag or player.gotcrystal)
				player.mo.custom2down = 1
				player.mo.scarfdodge = 5
				S_StartSound(player.mo, sfx_sfdge)
				if not (player.pflags & PF_ANALOGMODE)
					if (player.cmd.forwardmove > 0)
					and not (player.cmd.sidemove > 0)
					and not (player.cmd.sidemove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.forwardmove < 0)
					and not (player.cmd.sidemove > 0)
					and not (player.cmd.sidemove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.sidemove > 0)
					and not (player.cmd.forwardmove > 0)
					and not (player.cmd.forwardmove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.sidemove < 0)
					and not (player.cmd.forwardmove > 0)
					and not (player.cmd.forwardmove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
				else
					if not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT, player.mo.scale))
						P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
					else
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT/2, player.mo.scale))
						P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
					end
				end
			end
			//Max Speed
			if player.speed >= player.runspeed
			and (player.speed > 70*FRACUNIT)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				MaxSpeedRun(player)
			end
			//Super Particles Part 1
			if player.powers[pw_super]
			and not player.armaform
				local sparkle3 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				sparkle3.momx = P_RandomRange(-5, 5) * FRACUNIT
				sparkle3.momy = P_RandomRange(-5, 5) * FRACUNIT
				sparkle3.momz =  P_RandomRange(-5, 5) * FRACUNIT
				sparkle3.color = SKINCOLOR_KETCHUP
				sparkle3.colorized = true
				sparkle3.blendmode = AST_ADD
				sparkle3.scale = player.mo.scale/3*2
				sparkle3.source = player.mo
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					sparkle3.flags2 = $|MF2_DONTDRAW
				end
				for i = 1, 5
					local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SCARFARMAELECTICPARTICLE)
					thok.fuse = 8
					thok.color = SKINCOLOR_KETCHUP
					thok.colorized = true
					thok.blendmode = AST_ADD
					thok.eflags = $ | (P_RandomKey(2)*MFE_VERTICALFLIP)
					thok.scale = P_RandomRange(1,4)*player.mo.scale/8
					thok.momx = P_RandomRange(-16, 16)*player.mo.scale
					thok.momy = P_RandomRange(-16, 16)*player.mo.scale
					if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
						thok.flags2 = $|MF2_DONTDRAW
					end
				end
			end
			if not (player.cmd.buttons & BT_USE)
				player.mo.usedown = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM2)
			or not (P_IsObjectOnGround(player.mo))
				player.mo.custom2down = 0
			end
			//Super Particles Part 2
			if player.powers[pw_super]
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				local aura2 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-28, 28) * FRACUNIT, P_RandomRange(-28, 28) * FRACUNIT, P_RandomRange(0, 42) * FRACUNIT, MT_BOXSPARKLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				aura2.color = SKINCOLOR_PURPLE
				aura2.colorized = true
				aura2.blendmode = AST_ADD
				aura2.frame = TR_TRANS70
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					aura.flags2 = $|MF2_DONTDRAW
					aura2.flags2 = $|MF2_DONTDRAW
				end
			end
			if not player.powers[pw_extralife]
			and not (player.exiting)
			and player.playerstate == PST_LIVE
				if player.powers[pw_super] and not player.armaform then
					S_ChangeMusic("vsscar",true,player)
				elseif player.powers[pw_super] and player.armaform == true then
					if (leveltime % 10)
						if (leveltime % 10) == 1
						or (leveltime % 10) == 8
							player.mo.color = SKINCOLOR_ARMASCARF2
						elseif (leveltime % 10) == 2
						or (leveltime % 10) == 7
							player.mo.color = SKINCOLOR_ARMASCARF3
						elseif (leveltime % 10) == 3
						or (leveltime % 10) == 6
							player.mo.color = SKINCOLOR_ARMASCARF4
						elseif (leveltime % 10) == 4
						or (leveltime % 10) == 5
							player.mo.color = SKINCOLOR_ARMASCARF5
						or (leveltime % 10) == 7
							player.mo.color = SKINCOLOR_SILVER
						elseif (leveltime % 10) == 9
							player.mo.color = SKINCOLOR_ARMASCARF1
						end
					else
						player.mo.color = SKINCOLOR_ARMASCARF1
					end
					S_ChangeMusic("hyprsr", true, player)
				else
					P_RestoreMusic(player)
				end
			end
			//BonusType Voice
			if mapheaderinfo[gamemap].bonustype == 1 then
				if leveltime == 1
					S_StartSound(player.mo, sfx_scftpe)
				end
			end
		end
	end
	if not scarfpreent return end
	scarfpreent = $-1
	if scarfpreent return end
	print("\x89\Scarf The Wolf \x80\- \x88\Sprites by Dust Sans(Scarf The Wolf).", "\x87\Coding by Dust Sans(Scarf The Wolf)")
end)

addHook("PostThinkFrame", function()
    for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "scarf"
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not P_PlayerInPain(player)
		and not player.exiting
			if player.mo.sworddash > 1
			or (player.powers[pw_super] and player.armaform == true)
			or player.mo.scarfplasma > 1
				local ghost5 = P_SpawnGhostMobj(player.mo)
				ghost5.color = SKINCOLOR_RED
				ghost5.colorized = true
				ghost5.fuse = 1
				ghost5.blendmode = AST_ADD
				P_TeleportMove(ghost5, player.mo.x, player.mo.y, player.mo.z - 4*FRACUNIT)
				ghost5.frame = $|FF_ADD
				ghost5.scale = 1*FRACUNIT + 1*FRACUNIT/6
				if ghost5.tracer
					ghost5.tracer.fuse = ghost5.fuse
				end
			end
		end
	end
end)

addHook("SpinSpecial", function(player)
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf")
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.usedown == 1
		or player.weapondelay
		or P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.usedown = 1
		player.mo.sworddash = 0
		player.mo.swordjump = 0
		S_StartSound(player.mo, sfx_swordd)
		player.mo.swordstate = 12
		player.pflags = $1 & ~PF_SPINNING
		player.pflags = $1 & ~PF_THOKKED
		player.pflags = $1 & ~PF_JUMPED
		player.pflags = $1 & ~PF_SPINDOWN
		player.pflags = $1 & ~PF_STARTDASH
		player.mo.state = S_SCARF_SWORD1
		if player.mo.swordmah == nil
		or not player.mo.swordmah.valid
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		elseif player.mo.swordmah
		and player.mo.swordmah.valid
			P_RemoveMobj(player.mo.swordmah)
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		end
		if CBW_Battle
			player.weapondelay = 15
		else
			player.weapondelay = 10
		end
	end
end)

addHook("JumpSpinSpecial", function(player)
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf")
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.usedown == 1
		or player.weapondelay
		or P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.usedown = 1
		player.mo.sworddash = 0
		player.mo.swordjump = 0
		S_StartSound(player.mo, sfx_swordd)
		player.mo.swordstate = 12
		player.pflags = $1 & ~PF_SPINNING
		player.pflags = $1 & ~PF_THOKKED
		player.pflags = $1 & ~PF_JUMPED
		player.pflags = $1 & ~PF_SPINDOWN
		player.pflags = $1 & ~PF_STARTDASH
		player.mo.state = S_SCARF_SWORD1
		if player.mo.swordmah == nil
		or not player.mo.swordmah.valid
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		elseif player.mo.swordmah
		and player.mo.swordmah.valid
			P_RemoveMobj(player.mo.swordmah)
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		end
		if CBW_Battle
			player.weapondelay = 15
		else
			player.weapondelay = 10
		end
	end
end)

local function cupasoupbitch(player)
	if All7Emeralds(emeralds) and (player.rings > 49) and (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf") and not (player.powers[pw_super]) and not (player.pflags & PF_SPINNING) and not (player.powers[pw_carry]) and not (player.pflags & PF_THOKKED) and not (maptol & TOL_NIGHTS)
	and not (player.panim == PA_ABILITY) and not (player.panim == PA_ABILITY2) and not (player.panim == PA_PAIN) and not (player.panim == PA_ETC)
		return true
	else
		return false
	end
end

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "scarf"
	and player.mo.sworddash
	and not P_PlayerInPain(player)
	and not (P_IsObjectOnGround(player.mo))
	and player.playerstate == PST_LIVE
	and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
	and not player.powers[pw_carry]
	and not player.exiting
		scarffloat(player.mo, MT_GHOST, 4*FRACUNIT)
	end
	if player.mo and player.mo.skin == "scarf"
	and player.mo.swordjump
	and not P_PlayerInPain(player)
	and not (P_IsObjectOnGround(player.mo))
	and player.playerstate == PST_LIVE
	and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
	and not player.powers[pw_carry]
	and not player.exiting
		scarfjump(player.mo, MT_GHOST, 4*FRACUNIT)
	end
end)
	
local function SuperTramsformation(player)
	if not (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf") then return end 
	if player.cmd.buttons & BT_CUSTOM3
	and cupasoupbitch(player)
		player.charflags = $|SF_SUPER
		P_DoSuperTransformation(player)
		player.turnedsuper = true
		if player.rings < 149
			for i = 0, 6	
				local fa = (i*(ANGLE_180/3))
				local spawnemerald = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, player.spawnemerald)
				spawnemerald.radius = 5*FRACUNIT
				spawnemerald.dodgetimer = 4
				P_TeleportMove(spawnemerald, spawnemerald.x + FixedMul(sin(fa),spawnemerald.radius), spawnemerald.y + FixedMul(cos(fa),spawnemerald.radius), spawnemerald.z + player.mo.height/2)
				spawnemerald.playerparent = player.mo
				spawnemerald.goingin = nil
				spawnemerald.fa = fa
				player.spawnemerald = $ + 1
			end
		else
			for i = 0, 6	
				local fa = (i*(ANGLE_180/3))
				local spawnstarball = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, player.spawnstarball)
				spawnstarball.radius = 5*FRACUNIT
				spawnstarball.dodgetimer = 4
				P_TeleportMove(spawnstarball, spawnstarball.x + FixedMul(sin(fa),spawnstarball.radius), spawnstarball.y + FixedMul(cos(fa),spawnstarball.radius), spawnstarball.z + player.mo.height/2)
				spawnstarball.playerparent = player.mo
				spawnstarball.goingin = nil
				spawnstarball.fa = fa
				player.spawnstarball = $ + 1
			end
		end
	elseif (player.charflags & SF_SUPER)
	and not player.powers[pw_super]
	and not (maptol & TOL_NIGHTS)
		if player.rings < 149
			player.spawnemerald = MT_SCARF_EMERALD1
		else
			player.spawnstarball = MT_STARBALL1
		end
	end
	if player.turnedsuper
	and P_IsObjectOnGround(player.mo)
		player.turnedsuper = false
	end
end

addHook("PlayerThink", SuperTramsformation)

local function EmeraldMovement(emerald)
	if emerald and emerald.valid
		if emerald.radius > 0
			if emerald.radius < 60 * FRACUNIT
			and not emerald.goingin
				emerald.radius = $ + (5*FRACUNIT)
			elseif emerald.radius == 60*FRACUNIT
			and not emerald.goingin
				if emerald.dodgetimer > 0
					emerald.dodgetimer = $ - 1
				else
					emerald.goingin = true
				end
			elseif emerald.radius
			and emerald.goingin
				emerald.radius = $ - (3*FRACUNIT)
			end
			P_TeleportMove(emerald, emerald.playerparent.x + FixedMul(sin(emerald.fa),emerald.radius), emerald.playerparent.y + FixedMul(cos(emerald.fa),emerald.radius), emerald.playerparent.z + emerald.playerparent.height/2)
			emerald.fa = $ + (ANGLE_180/24)
		else
			P_RemoveMobj(emerald)
		end
	end
end

addHook("MobjThinker", EmeraldMovement, MT_STARBALL1)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL2)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL3)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL4)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL5)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL6)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL7)

addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD1)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD2)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD3)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD4)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD5)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD6)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD7)

addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "scarf" and player.playerstate == PST_LIVE)
	and player.charability == CA_NONE
	and not (player.pflags & PF_THOKKED)
	and not player.armaform
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
		S_StartSound(player.mo, sfx_sfdsh)
		player.mo.sworddash = 18
		player.pflags = $1|PF_THOKKED
		local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
		thok.state = S_FACESTABBERSPEAR
		thok.angle = player.drawangle+ANGLE_90
		thok.scale = player.mo.scale/2+FRACUNIT/4
		thok.fuse = 8
		thok.color = SKINCOLOR_RED
		thok.colorized = true
		thok.blendmode = AST_ADD
		if P_RandomChance(FRACUNIT/70) then 
			S_StartSound(player.mo, sfx_scf2) 
		end
	end
	if (player.mo and player.mo.valid and player.mo.skin == "scarf" and player.playerstate == PST_LIVE)
	and player.charability == CA_NONE
	and not player.armaform
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
		if not player.mo.sworddash
		and (player.mo.state == S_PLAY_FALL)
			S_StartSound(player.mo, sfx_sfdsh)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.state = S_FACESTABBERSPEAR
			thok.angle = player.drawangle+ANGLE_90
			thok.scale = player.mo.scale/2+FRACUNIT/4
			thok.fuse = 8
			thok.destscale = 0
			thok.color = SKINCOLOR_RED
			thok.colorized = true
			thok.blendmode = AST_ADD
			thok.flags2 = $1|MF2_SPLAT
			player.mo.swordjump = 15
			if P_RandomChance(FRACUNIT/70) then 
				S_StartSound(player.mo, sfx_scf9)
			end
		end
	end
end)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if plmo.z + plmo.height < spike.z or spike.z + spike.height < plmo.z then return end
	local player = plmo.player
	if player.mo.swordstate > 1
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if (plmo.z > spike.z+spike.height*4) or (spike.z > plmo.z+plmo.height*2) then return end
	local player = plmo.player
	if player.mo.swordstate > 1
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_WALLSPIKE)

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
	if not mobj.source return end
		mobj.lifetime = $ or 0
		P_TeleportMove(mobj, mobj.x + mobj.lifetime * mobj.momx, mobj.y + mobj.lifetime * mobj.momy, mobj.z + 17*FRACUNIT + mobj.lifetime * mobj.momz)
		mobj.lifetime = $ + 1
	end
end, MT_ELECTRICJUMPPARTICLE)

addHook("MobjThinker", function(mo)
	if mo and mo.valid 
	and mo.type == MT_LIGHTBURST
		mo.color = SKINCOLOR_SKY
		mo.colorized = true
		mo.blendmode = AST_ADD
		local sparkle = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_ELECTRICJUMPPARTICLE)
		sparkle.momx = P_RandomRange(-5, 5) * FRACUNIT
		sparkle.momy = P_RandomRange(-5, 5) * FRACUNIT
		sparkle.momz =  P_RandomRange(-5, 5) * FRACUNIT
		sparkle.scale = mo.scale/3*2
		sparkle.source = mo
	end
end, MT_LIGHTBURST)

// death animation
local function ScarfDeath(target, inflictor, source, damage)
	if target
	and target.player
		if target.skin == "scarf"
			if damage == DMG_FIRE
				target.player.scarf_burnt = true
				return false
			elseif damage == DMG_ELECTRIC
				target.player.scarf_elec = true
				return false
			elseif damage == DMG_SPIKE
				target.player.scarf_spike = true
				return false
			elseif damage == DMG_DROWNED or damage == DMG_SPACEDROWN
				target.player.scarf_drowned = true
				return false
			elseif damage == DMG_DEATHPIT
				target.player.scarf_deathpit = true
				return false
			elseif damage == DMG_CRUSHED
				target.player.scarf_crushed = true
				return false
			end
		end
	end
end

addHook("MobjDeath", ScarfDeath)

local function DeathUnset(player)
	player.scarf_burnt = false
	player.scarf_elec = false
	player.scarf_spike = false
	player.scarf_drowned = false
	player.scarf_deathpit = false
	player.scarf_crushed = false
end

addHook("PlayerSpawn", DeathUnset)

local function StateDeath(player)
	if player.scarf_burnt
	and not player.trahtebedohdoh_tistalyodoi
		if not (leveltime & 3)
			local burndeath = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*FRACUNIT),player.mo.y+(P_RandomRange(-10,10)*FRACUNIT),player.mo.z+(P_RandomRange(-10,10)*FRACUNIT),MT_FLAMEPARTICLE)
			burndeath.color = SKINCOLOR_RED
			burndeath.colorized = true
			burndeath.blendmode = AST_ADD
			burndeath.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
		end
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
			P_FlashPal(player, PAL_NUKE, 3)
			P_StartQuake(9*FRACUNIT, 3)
			if P_PlayerTouchingSectorSpecial(player, 1, 3) and P_IsObjectOnGround(player.mo)
				for d = 1,6
					local burningparticle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
					P_InstaThrust(burningparticle, ANGLE_45*d, 20*player.mo.scale)
					burningparticle.scale = player.mo.scale
					burningparticle.state = S_LAVASPLISH
					burningparticle.flags = $ & ~MF_NOGRAVITY
					P_SetObjectMomZ(burningparticle, 7*player.mo.scale)
				end
				for c = 1,12
					local burningparticle2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PUMATRAIL)
					P_InstaThrust(burningparticle2, (ANGLE_45/2)*c, 30*player.mo.scale)
					burningparticle2.scale = player.mo.scale
					burningparticle2.flags = $ & ~MF_NOGRAVITY
					P_SetObjectMomZ(burningparticle2, 14*player.mo.scale)
				end
			end
		end
		if player.deathstart
			S_StartSound(s, sfx_s3k48)
		end
		player.mo.state = S_SCARF_BURN
		player.mo.rollangle = $+ANGLE_22h
	elseif player.scarf_elec
	and not player.trahtebedohdoh_tistalyodoi
		player.mo.rollangle = $+ANGLE_22h
		if not (leveltime & 3)
			local electrodeath = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*FRACUNIT),player.mo.y+(P_RandomRange(-10,10)*FRACUNIT),player.mo.z+(P_RandomRange(-10,10)*FRACUNIT),MT_WATERZAP)
			electrodeath.blendmode = AST_ADD
			electrodeath.frame = FF_TRANS50
			electrodeath.color = P_RandomRange(SKINCOLOR_SUPERORANGE3, SKINCOLOR_SUPERGOLD1, SKINCOLOR_YELLOW)
			electrodeath.colorized = true
			electrodeath.scale = $*P_RandomRange(2,6)
			electrodeath.rollangle = player.mo.rollangle+(P_RandomRange(-90,90)*ANG1)
			electrodeath.tics = $+P_RandomRange(2,15)
			electrodeath.frame = $|FF_FULLBRIGHT
			electrodeath.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
			local electricghost = P_SpawnGhostMobj(player.mo)
			P_InstaThrust(electricghost, P_RandomRange(1,359)*ANG1, 6*player.mo.scale)
			P_SetObjectMomZ(electricghost, P_RandomRange(3,-2)*player.mo.scale, true)
			electricghost.rollangle = player.mo.rollangle+(P_RandomRange(-40,40)*ANG1)
			electricghost.spriteyscale = $*4/P_RandomRange(1,10)
			electricghost.spritexscale = $*4/P_RandomRange(1,10)
			electricghost.color = P_RandomRange(SKINCOLOR_SUPERORANGE3, SKINCOLOR_SUPERGOLD1, SKINCOLOR_YELLOW)
			electricghost.colorized = true
			electricghost.blendmode = AST_ADD
			electricghost.state = S_SCARF_BURN
		end
		if player.mo.state == S_PLAY_DEAD
			P_FlashPal(player, PAL_WHITE, 3)
			S_StartSound(player.mo, sfx_buzz2)
		end
		if (leveltime & 1) == 0
			player.mo.state = S_SCARF_ELECTRO1
		else
			player.mo.state = S_SCARF_ELECTRO3
		end
	elseif player.scarf_spike
	and not player.trahtebedohdoh_tistalyodoi
		player.mo.state = S_SCARF_BURN
		player.mo.rollangle = $+ANGLE_22h
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
			P_FlashPal(player, PAL_RECYCLE, 3)
			P_StartQuake(9*FRACUNIT, 3)
		end
	elseif player.scarf_drowned
	and not player.trahtebedohdoh_tistalyodoi
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
			P_FlashPal(player, PAL_WHITE, 3)
			P_StartQuake(9*FRACUNIT, 3)
		end
		player.mo.state = S_SCARF_BURN
		player.mo.rollangle = $+ANGLE_22h
	elseif player.scarf_deathpit
	and not player.trahtebedohdoh_tistalyodoi
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
		end
		player.mo.state = S_PLAY_FALL
		P_SetObjectMomZ(player.mo, -15*FRACUNIT, false)
	elseif player.scarf_crushed
	and not player.trahtebedohdoh_tistalyodoi
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
		end
		player.mo.state = S_SCARF_CRUSH
		player.mo.flags = $ & ~MF_NOCLIP
		player.mo.flags = $ & ~MF_NOCLIPHEIGHT
	end
end

addHook("PlayerThink", StateDeath)